#########################################################################
# Secret
#
# Author:    Fabio Santos B. da Silva
# Email :    fsbsilva@gmail.com
# Version:   0.1.0
# Date:      06/02/2018
# Purpose:   It is going to encrypt and decrypt a plain_text
#########################################################################

module PuppetX; end
module PuppetX::Secret; end

module PuppetX::Secret::Secret

    DEFAULT_KEY = '41254157g5o9s7h8m3e612awpmon!5jk'
    DEFAULT_IV  = 'nxWo3eFMpPxxY+sbade4eg=='

    def self.random_iv()
        cipher = OpenSSL::Cipher::Cipher.new("aes-256-cbc")
        cipher.encrypt
        iv_base64 = Base64.strict_encode64(cipher.random_iv)
        return iv_base64
    end

    def self.encrypt(plain_text, secretkey = nil, iv_base64 = nil)
        begin
            # create the cipher for encrypting
            cipher = OpenSSL::Cipher::Cipher.new("aes-256-cbc")
            cipher.encrypt

            # you will need to store these for later, in order to decrypt your data
            secretkey ||= DEFAULT_KEY
            iv_base64 ||= DEFAULT_IV
            # iv_base64 ||= Base64.strict_encode64(cipher.random_iv)

            key = Digest::SHA1.hexdigest(secretkey)

            # load them into the cipher
            cipher.key = key
            cipher.iv = Base64.strict_decode64(iv_base64)

            # encrypt the message
            encrypted = cipher.update(plain_text)
            encrypted << cipher.final

            encrypted_encode64 = Base64.strict_encode64(encrypted)

            puts "encrypted: #{encrypted_encode64}"
            puts "secretkey: #{secretkey}"
            puts "iv_base64: #{iv_base64}"
        rescue
          fail "Opss!! There is a bug on PuppetX::Secret::Secret.encrypt method!"
          raise
        end
    end

    def self.decrypt(encrypted_encode64, secretkey = nil, iv_base64 = nil)
        begin
            secretkey ||= DEFAULT_KEY
            iv_base64 ||= DEFAULT_IV
            encrypted_decode64 = Base64.strict_decode64(encrypted_encode64)

            cipher = OpenSSL::Cipher::Cipher.new("aes-256-cbc")
            cipher.decrypt
            cipher.key = Digest::SHA1.hexdigest(secretkey)
            cipher.iv = Base64.strict_decode64(iv_base64)

            decrypted = cipher.update(encrypted_decode64)
            decrypted << cipher.final

            return decrypted
        rescue
          fail "Opss!! There is a bug on PuppetX::Secret::Secret.decrypt method!"
          raise
        end

    end
end
